Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractRasterStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractRasterStoreProvider.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractRasterStoreProvider.java	(revision 43867)
@@ -66,7 +66,7 @@
  */
 public abstract class AbstractRasterStoreProvider extends AbstractDisposable implements RasterStoreProvider{
 
-    private static final Logger LOG =
+    protected static final Logger LOG =
         LoggerFactory.getLogger(AbstractRasterStoreProvider.class);
 
     private RasterStoreProviderServices store;
@@ -258,7 +258,7 @@
         try {
             open();
         } catch (Exception e) {
-            throw new RuntimeException();
+            throw new RuntimeException(e);
         }
     }
 
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.png/src/main/java/org/gvsig/fmap/dal/file/png/PngLibrary.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.png/src/main/java/org/gvsig/fmap/dal/file/png/PngLibrary.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.png/src/main/java/org/gvsig/fmap/dal/file/png/PngLibrary.java	(revision 43867)
@@ -99,7 +99,8 @@
                     new ImageIOFileSystemServerProviderFactory(
                             NAME,
                             DESCRIPTION,
-                            FILE_EXTENSIONS
+                            FILE_EXTENSIONS,
+                            true
                     )
             );
         } catch (Exception e) {
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/resources/META-INF/services/org.gvsig.tools.library.Library
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/resources/META-INF/services/org.gvsig.tools.library.Library	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/resources/META-INF/services/org.gvsig.tools.library.Library	(revision 43867)
@@ -0,0 +1 @@
+org.gvsig.fmap.dal.file.bsq.BSQLibrary
\ No newline at end of file
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQBandPageManager.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQBandPageManager.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQBandPageManager.java	(revision 43867)
@@ -0,0 +1,148 @@
+
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.io.File;
+import java.io.IOException;
+import java.io.RandomAccessFile;
+import java.nio.Buffer;
+import java.nio.ByteBuffer;
+import java.nio.DoubleBuffer;
+import java.nio.FloatBuffer;
+import java.nio.IntBuffer;
+import java.nio.ShortBuffer;
+import org.apache.commons.io.IOUtils;
+import org.gvsig.raster.lib.buffer.api.BandInfo;
+import org.gvsig.raster.lib.buffer.api.BandPageManager;
+import org.gvsig.raster.lib.buffer.api.BufferLocator;
+import org.gvsig.raster.lib.buffer.api.BufferManager;
+import org.gvsig.tools.dispose.impl.AbstractDisposable;
+import org.gvsig.tools.exception.BaseException;
+
+public class BSQBandPageManager extends AbstractDisposable implements BandPageManager {
+
+    private RandomAccessFile  raf;
+    private final int rows;
+    private final int columns;
+    private final int dataType;
+    private final File file;
+    private final long startpos;
+
+    /**
+     * @param file
+     * @param startpos
+     * @param rows
+     * @param columns
+     * @param dataType
+     * @throws IOException
+     */
+    public BSQBandPageManager(File file, long startpos, int rows, int columns, int dataType) throws IOException {
+        this.rows = rows;
+        this.columns = columns;
+        this.dataType = dataType;
+        this.file = file;
+        this.startpos = startpos;
+
+        this.raf = new RandomAccessFile(this.file, "rw");
+        // BufferManager bufferManager = BufferLocator.getBufferManager();
+        //raf.setLength(rows*columns*bufferManager.getDataTypeSize(dataType));
+
+    }
+
+    @Override
+    public void load(Buffer buffer, int row, int rows, int dataType) throws IOException {
+
+        long pos = row*this.columns + this.startpos;
+        raf.seek(pos);
+        BufferManager bufferManager = BufferLocator.getBufferManager();
+        int dataTypeSize = bufferManager.getDataTypeSize(dataType);
+        byte[] byteArray = new byte[buffer.capacity() * dataTypeSize];
+        raf.read(byteArray);
+        buffer.rewind();
+
+        switch (dataType) {
+        case BufferManager.TYPE_BYTE:
+            //FIXME: Elegir cual de las dos siguientes maneras de hacerlo es la idónea
+
+            ((ByteBuffer) buffer).put(byteArray, 0, byteArray.length);
+//            System.arraycopy(byteArray, 0, ((ByteBuffer) buffer).array(), 0, byteArray.length);
+            break;
+        case BufferManager.TYPE_SHORT:
+        case BufferManager.TYPE_USHORT:
+            for( int cell =0 ; cell<byteArray.length ; cell++ ) {
+                ((ShortBuffer) buffer).put((int)(cell/dataTypeSize), byteArray[cell]);
+            }
+            break;
+        case BufferManager.TYPE_INT:
+            for( int cell =0 ; cell<byteArray.length ; cell++ ) {
+                ((IntBuffer) buffer).put((int)(cell/dataTypeSize), byteArray[cell]);
+            }
+            break;
+        case BufferManager.TYPE_FLOAT:
+            for( int cell =0 ; cell<byteArray.length ; cell++ ) {
+                ((FloatBuffer) buffer).put((int)(cell/dataTypeSize), byteArray[cell]);
+            }
+            break;
+
+        case BufferManager.TYPE_DOUBLE:
+            for( int cell =0 ; cell<byteArray.length ; cell++ ) {
+                ((DoubleBuffer) buffer).put((int)(cell/dataTypeSize), byteArray[cell]);
+            }
+            break;
+
+        default:
+            throw new IllegalArgumentException("Data Type " + dataType + " not supported.");
+        }
+    }
+
+    @Override
+    public void save(Buffer buffer, int row, int rows, int dataType) throws IOException {
+
+        long pos = row*this.columns + this.startpos;
+        raf.seek(pos);
+
+        BufferManager bufferManager = BufferLocator.getBufferManager();
+        ByteBuffer byteBuffer = ByteBuffer.allocate(buffer.capacity() * bufferManager.getDataTypeSize(dataType));
+        switch (dataType) {
+        case BufferManager.TYPE_BYTE:
+            byteBuffer.put(((ByteBuffer)buffer).array());
+            break;
+        case BufferManager.TYPE_SHORT:
+        case BufferManager.TYPE_USHORT:
+            ShortBuffer byteAsShortBuffer = byteBuffer.asShortBuffer();
+            byteAsShortBuffer.put((short[]) buffer.array());
+            break;
+        case BufferManager.TYPE_INT:
+            IntBuffer byteAsIntBuffer = byteBuffer.asIntBuffer();
+            byteAsIntBuffer.put((int[]) buffer.array());
+            break;
+        case BufferManager.TYPE_FLOAT:
+            FloatBuffer byteAsFloatBuffer = byteBuffer.asFloatBuffer();
+            byteAsFloatBuffer.put((float[]) buffer.array());
+            break;
+        case BufferManager.TYPE_DOUBLE:
+            DoubleBuffer byteAsDoubleBuffer = byteBuffer.asDoubleBuffer();
+            byteAsDoubleBuffer.put((double[]) buffer.array());
+            break;
+        default:
+            throw new IllegalArgumentException("Data Type " + dataType + " not supported.");
+        }
+        raf.write(byteBuffer.array());
+
+    }
+
+    @Override
+    public boolean isSupportedSave() {
+        return true;
+    }
+
+    @Override
+    public BandInfo getBandInfo() {
+        return null;
+    }
+
+    @Override
+    protected void doDispose() throws BaseException {
+        IOUtils.closeQuietly(this.raf);
+        this.raf = null;
+    }
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/FileOpenRasterStoreParameters.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/FileOpenRasterStoreParameters.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/FileOpenRasterStoreParameters.java	(revision 43867)
@@ -0,0 +1,83 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.io.File;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import org.gvsig.fmap.dal.FileHelper;
+import org.gvsig.fmap.dal.raster.OpenRasterStoreParameters;
+import org.gvsig.fmap.dal.raster.spi.AbstractOpenRasterStoreParameters;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
+import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
+import org.gvsig.tools.dynobject.DelegatedDynObject;
+
+
+public class FileOpenRasterStoreParameters 
+        extends 
+            AbstractOpenRasterStoreParameters 
+        implements
+            OpenRasterStoreParameters, 
+            FilesystemStoreParameters
+    {
+
+    protected static final Logger logger = LoggerFactory.getLogger(FileOpenRasterStoreParameters.class);
+
+    public static final String FILE_PARAMTER_NAME = "file";
+
+    protected DelegatedDynObject parameters;
+
+    /**
+     * Constructor
+     * @param name
+     */
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public FileOpenRasterStoreParameters(String name) {
+        super();
+        this.parameters = (DelegatedDynObject) FileHelper.newParameters(name+"StoreProviderParameters");
+        this.setDynValue(DataStoreProviderServices.PROVIDER_PARAMTER_NAME, name);
+    }
+
+    @Override
+    public boolean isValid() {
+        return (this.getFile() != null);
+    }
+
+    @Override
+    public File getFile() {
+        return (File) this.getDynValue(FILE_PARAMTER_NAME);
+    }
+
+    @Override
+    public void setFile(File file) {
+        this.setDynValue(FILE_PARAMTER_NAME, file);
+    }
+
+    @Override
+    protected DelegatedDynObject getDelegatedDynObject() {
+        return parameters;
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProviderFactory.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProviderFactory.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProviderFactory.java	(revision 43867)
@@ -0,0 +1,71 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2018 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.io.File;
+
+import org.apache.commons.io.FilenameUtils;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.impl.AbstractFilesystemServerExplorerProviderFactory;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProvider;
+
+
+public class BSQFileSystemServerProviderFactory extends AbstractFilesystemServerExplorerProviderFactory {
+
+    protected String[] fileExtensions;
+    protected boolean canCreate;
+
+    public BSQFileSystemServerProviderFactory(
+            String name, 
+            String description, 
+            String[] fileExtensions
+        ) {
+        this(name, description, fileExtensions, false);
+    }
+
+    public BSQFileSystemServerProviderFactory(
+            String name, 
+            String description, 
+            String[] fileExtensions,
+            boolean canCreate
+        ) {
+        super(name, description);
+        this.fileExtensions = fileExtensions;
+        this.canCreate = canCreate;
+    }
+
+    @Override
+    public FilesystemServerExplorerProvider create() {
+        return new BSQFileSystemServerProvider(
+                this.getName(),
+                this.getDescription(),
+                this.fileExtensions,
+                this.canCreate
+        );
+    }
+
+    @Override
+    public boolean accept(File pathname) {
+        return FilenameUtils.isExtension(pathname.getName().toLowerCase(), this.fileExtensions);
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQStoreProviderFactory.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQStoreProviderFactory.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQStoreProviderFactory.java	(revision 43867)
@@ -0,0 +1,60 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.file.bsq;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import org.gvsig.fmap.dal.DataParameters;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.dal.raster.OpenRasterStoreParameters;
+import org.gvsig.fmap.dal.raster.spi.AbstractRasterStoreProviderFactory;
+import org.gvsig.fmap.dal.raster.spi.RasterStoreProvider;
+import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
+
+
+public class BSQStoreProviderFactory extends AbstractRasterStoreProviderFactory {
+
+    protected static final Logger logger = LoggerFactory.getLogger(BSQStoreProviderFactory.class);
+
+    public BSQStoreProviderFactory(String name, String description) {
+        super(name, description);
+    }
+
+    @Override
+    public RasterStoreProvider createProvider(DataParameters parameters,
+        DataStoreProviderServices providerServices) throws InitializeException {
+        return new BSQStoreProvider(
+                this.getName(), 
+                this.getDescription(), 
+                (OpenRasterStoreParameters)parameters, 
+                providerServices
+        );
+    }
+
+    @Override
+    public OpenRasterStoreParameters createParameters() {
+        return new FileOpenRasterStoreParameters(this.getName());
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQLibrary.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQLibrary.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQLibrary.java	(revision 43867)
@@ -0,0 +1,114 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.gvsig.fmap.dal.DALFileLibrary;
+import org.gvsig.fmap.dal.DALFileLocator;
+import org.gvsig.fmap.dal.DALLibrary;
+import org.gvsig.fmap.dal.FileHelper;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerManager;
+import org.gvsig.fmap.dal.spi.DALSPILocator;
+import org.gvsig.fmap.dal.spi.DataManagerProviderServices;
+import org.gvsig.metadata.MetadataLocator;
+import org.gvsig.metadata.MetadataManager;
+import org.gvsig.metadata.exceptions.MetadataException;
+import org.gvsig.tools.dynobject.DynClass;
+import org.gvsig.tools.library.AbstractLibrary;
+import org.gvsig.tools.library.LibraryException;
+
+/**
+ * BSQ, Band Sequential Format, Library to register provider components
+ *
+ */
+public class BSQLibrary extends AbstractLibrary {
+
+    public static String NAME = "BSQ";
+    public static String DESCRIPTION = "BSQ provider";
+    public static String[] FILE_EXTENSIONS = new String[]{"bsq"};
+
+    @Override
+    public void doRegistration() {
+        registerAsServiceOf(DALLibrary.class);
+        require(DALFileLibrary.class);
+
+    }
+
+    @Override
+    protected void doInitialize() throws LibraryException {
+    }
+
+    @Override
+    protected void doPostInitialize() throws LibraryException {
+        List<Throwable> exs = new ArrayList<>();
+
+
+        FileHelper.registerParametersDefinition(
+                NAME + "StoreProviderParameters",
+                FileOpenRasterStoreParameters.class,
+                this.getClass().getClassLoader(),
+                this.getClass().getResource(NAME + "Parameters.xml"));
+        try {
+            try {
+                FileHelper.registerMetadataDefinition(
+                        NAME,
+                        BSQStoreProvider.class,
+                        this.getClass().getClassLoader(),
+                        this.getClass().getResource(NAME + "Metadata.xml"));
+            } catch (MetadataException e) {
+                exs.add(e);
+            }
+            
+            DataManagerProviderServices datamanager = DALSPILocator.getDataManagerProviderServices();
+            FilesystemServerExplorerManager explorerManager = DALFileLocator.getFilesystemServerExplorerManager();
+
+            if (!datamanager.getStoreProviders().contains(NAME)) {
+                datamanager.registerStoreProviderFactory(
+                        new BSQStoreProviderFactory(
+                                NAME,
+                                DESCRIPTION));
+            }
+            explorerManager.registerProviderFactory(
+                    new BSQFileSystemServerProviderFactory(
+                            NAME,
+                            DESCRIPTION,
+                            FILE_EXTENSIONS,
+                            true
+                    )
+            );
+        } catch (Exception e) {
+            exs.add(e);
+        }
+
+        if (exs.size() > 0) {
+            throw new LibraryException(this.getClass(), exs);
+        }
+    }
+
+    public static DynClass getMatadataDefinition() {
+        MetadataManager metadataManager = MetadataLocator.getMetadataManager();
+        DynClass metadataDefinition = (DynClass) metadataManager.getDefinition(NAME);
+        return metadataDefinition;
+    }}
